"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const winston = require("winston");
function Logger() {
    let logger;
    return {
        start({ config }, _, stop) {
            return __awaiter(this, void 0, void 0, function* () {
                return logger = new winston.Logger(prepareConfig(config || {})).on('error', stop);
            });
        },
        stop() {
            return __awaiter(this, void 0, void 0, function* () {
                if (logger)
                    logger.close();
            });
        }
    };
}
exports.Logger = Logger;
(function (Logger) {
    Logger.transports = winston.transports;
})(Logger = exports.Logger || (exports.Logger = {}));
function prepareConfig(config) {
    const transports = (config.transportFactories || [])
        .map(factory => factory());
    return Object.assign({}, config, { transports });
}
exports.default = Logger;
exports.transports = winston.transports;
